/**
 * Copyright (c) 2008-2012 EBM WebSourcing, 2012-2016 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the New BSD License (3-clause license).
 *
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the New BSD License (3-clause license)
 * for more details.
 *
 * You should have received a copy of the New BSD License (3-clause license)
 * along with this program/library; If not, see http://directory.fsf.org/wiki/License:BSD_3Clause/
 * for the New BSD License (3-clause license).
 */
 
package org.ow2.easywsdl.extensions.wsdl4bpel.api;

import java.io.Serializable;
import java.util.List;

import javax.xml.namespace.QName;

/**
 * This interface represents all the WSDL Elements.
 * @author Nicolas Salatge - EBM WebSourcing
 */
public interface WSDL4BPELElement extends Serializable  {

    // getter
    List<PartnerLinkType> getPartnerLinkTypes() throws WSDL4BPELException; 
    
    PartnerLinkType getPartnerLinkType(QName plt) throws WSDL4BPELException;
    
    List<Property> getProperties() throws WSDL4BPELException; 
    
    Property getProperty(QName property) throws WSDL4BPELException; 
    
    List<PropertyAlias> getAllPropertyAliases() throws WSDL4BPELException; 
    
    List<PropertyAlias> getPropertyAliases4ThisProperty(QName property) throws WSDL4BPELException; 

    // add
    void addPartnerLinkType(PartnerLinkType plt) throws WSDL4BPELException;

    // remove
    PartnerLinkType removePartnerLinkType(PartnerLinkType plt) throws WSDL4BPELException;

    // remove all
    List<PartnerLinkType> removeAllPartnerLinkTypes() throws WSDL4BPELException;

}
