/**
 * Copyright (c) 2008-2012 EBM WebSourcing, 2012-2016 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the New BSD License (3-clause license).
 *
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the New BSD License (3-clause license)
 * for more details.
 *
 * You should have received a copy of the New BSD License (3-clause license)
 * along with this program/library; If not, see http://directory.fsf.org/wiki/License:BSD_3Clause/
 * for the New BSD License (3-clause license).
 */
 
package org.ow2.easywsdl.extensions.wsdl4bpel.impl;

import java.util.Map;

import javax.xml.namespace.QName;

import org.ow2.easywsdl.extensions.wsdl4bpel.api.PropertyAlias;
import org.ow2.easywsdl.extensions.wsdl4bpel.api.Query;
import org.ow2.easywsdl.wsdl.api.Description;
import org.ow2.easywsdl.wsdl.api.WSDLException;
import org.ow2.easywsdl.wsdl.api.abstractElmt.AbstractWSDLElementImpl;

/** 
* @author Nicolas Salatge - EBM WebSourcing
*/
public class PropertyAliasImpl extends AbstractWSDLElementImpl<org.ow2.easywsdl.extensions.wsdl4bpel.org.oasis_open.docs.wsbpel._2_0.varprop.PropertyAlias> implements PropertyAlias {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	
	private Query query = null;
	
	private Description description = null;
	
    public PropertyAliasImpl(final org.ow2.easywsdl.extensions.wsdl4bpel.org.oasis_open.docs.wsbpel._2_0.varprop.PropertyAlias property, final Description desc) {
        super(property, (AbstractWSDLElementImpl) desc);
        this.description = desc;
        
        this.query = new QueryImpl(this.model.getQuery(), this);
        
    }

	/**
	 * @return the desc
	 */
	public Description getDescription() {
		return description;
	}



	@Override
	public Map<QName, String> getOtherAttributes() throws WSDLException {
		return this.model.getOtherAttributes();
	}

	public QName getElement() {
		return this.model.getElement();
	}

	public QName getType() {
		return this.model.getType();
	}


	public QName getMessageType() {
		return this.model.getMessageType();
	}

	public String getPart() {
		return this.model.getPart();
	}
	
	public QName getPropertyName() {
		return this.model.getPropertyName();
	}

	
	public Query getQuery() {
		return this.query;
	}
}
