/**
 * Copyright (c) 2008-2012 EBM WebSourcing, 2012-2016 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the New BSD License (3-clause license).
 *
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the New BSD License (3-clause license)
 * for more details.
 *
 * You should have received a copy of the New BSD License (3-clause license)
 * along with this program/library; If not, see http://directory.fsf.org/wiki/License:BSD_3Clause/
 * for the New BSD License (3-clause license).
 */
 
package org.ow2.easywsdl.extensions.wsdl4bpel.impl;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.xml.namespace.QName;

import org.ow2.easywsdl.extensions.wsdl4bpel.api.Property;
import org.ow2.easywsdl.extensions.wsdl4bpel.api.Role;
import org.ow2.easywsdl.wsdl.api.Description;
import org.ow2.easywsdl.wsdl.api.WSDLException;
import org.ow2.easywsdl.wsdl.api.abstractElmt.AbstractWSDLElementImpl;

/** 
* @author Nicolas Salatge - EBM WebSourcing
*/
public class PropertyImpl extends AbstractWSDLElementImpl<org.ow2.easywsdl.extensions.wsdl4bpel.org.oasis_open.docs.wsbpel._2_0.varprop.Property> implements Property {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	
	private List<Role> roles = new ArrayList<Role>();
	
	private Description description = null;
	
    public PropertyImpl(final org.ow2.easywsdl.extensions.wsdl4bpel.org.oasis_open.docs.wsbpel._2_0.varprop.Property property, final Description desc) {
        super(property, (AbstractWSDLElementImpl) desc);
        this.description = desc;
        
    
    }

	/**
	 * @return the desc
	 */
	public Description getDescription() {
		return description;
	}


	public QName getQName() {
		return new QName(this.description.getTargetNamespace(), this.model.getName());
	}

	public void setQName(QName name) {
		this.model.setName(name.getLocalPart());
	}

	@Override
	public Map<QName, String> getOtherAttributes() throws WSDLException {
		return this.model.getOtherAttributes();
	}

	public QName getElement() {
		return this.model.getElement();
	}

	public QName getType() {
		return this.model.getType();
	}


	
}
