/**
 * Copyright (c) 2008-2012 EBM WebSourcing, 2012-2016 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the New BSD License (3-clause license).
 *
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the New BSD License (3-clause license)
 * for more details.
 *
 * You should have received a copy of the New BSD License (3-clause license)
 * along with this program/library; If not, see http://directory.fsf.org/wiki/License:BSD_3Clause/
 * for the New BSD License (3-clause license).
 */
 
package org.ow2.easywsdl.extensions.wsdl4bpel.impl;

import java.util.Map;

import javax.xml.namespace.QName;

import org.ow2.easywsdl.extensions.wsdl4bpel.api.Query;
import org.ow2.easywsdl.wsdl.api.WSDLException;
import org.ow2.easywsdl.wsdl.api.abstractElmt.AbstractWSDLElementImpl;

/** 
* @author Nicolas Salatge - EBM WebSourcing
*/
public class QueryImpl extends AbstractWSDLElementImpl<org.ow2.easywsdl.extensions.wsdl4bpel.org.oasis_open.docs.wsbpel._2_0.varprop.TQuery> implements Query {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	
    public QueryImpl(final org.ow2.easywsdl.extensions.wsdl4bpel.org.oasis_open.docs.wsbpel._2_0.varprop.TQuery query, final AbstractWSDLElementImpl parent) {
        super(query, (AbstractWSDLElementImpl) parent);
    }


	@Override
	public Map<QName, String> getOtherAttributes() throws WSDLException {
		return this.model.getOtherAttributes();
	}

	public String getQueryLanguage() {
		return this.model.getQueryLanguage();
	}

	public String getContentString() {
		String res = null;
		if(this.model.getContent() != null && this.model.getContent().size() > 0) {
			if(this.model.getContent().get(0) instanceof String) {
				res = (String) this.model.getContent().get(0);
			}
		}
		return res;
	}


	
}
