/**
 * Copyright (c) 2008-2012 EBM WebSourcing, 2012-2016 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the New BSD License (3-clause license).
 *
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the New BSD License (3-clause license)
 * for more details.
 *
 * You should have received a copy of the New BSD License (3-clause license)
 * along with this program/library; If not, see http://directory.fsf.org/wiki/License:BSD_3Clause/
 * for the New BSD License (3-clause license).
 */
 
package org.ow2.easywsdl.extensions.wsdl4bpel.impl.inout;

import org.ow2.easywsdl.extensions.wsdl4bpel.api.Description;
import org.ow2.easywsdl.extensions.wsdl4bpel.api.WSDL4BPELException;
import org.ow2.easywsdl.extensions.wsdl4bpel.api.WSDL4BPELWriter;
import org.ow2.easywsdl.wsdl.WSDLFactory;
import org.ow2.easywsdl.wsdl.api.WSDLException;
import org.ow2.easywsdl.wsdl.api.WSDLWriter;
import org.ow2.easywsdl.wsdl.decorator.DecoratorDescriptionImpl;
import org.w3c.dom.Document;

/**
 * @author Nicolas Salatge - EBM WebSourcing
 */
public class WSDL4BPELWriterImpl implements WSDL4BPELWriter {

    private WSDLWriter writer = null;    

    public WSDL4BPELWriterImpl() throws WSDL4BPELException {
        try {
            this.writer = WSDLFactory.newInstance().newWSDLWriter();
        } catch (final WSDLException e) {
            throw new WSDL4BPELException(e);
        }
    }

    @SuppressWarnings("unchecked")
    public Document getDocument(final Description wsdlDef) throws WSDL4BPELException {
        Document res = null;
        try {
            res = this.writer.getDocument(((DecoratorDescriptionImpl) wsdlDef).getFirstDescription());
        } catch (final WSDLException e) {
            throw new WSDL4BPELException(e);
        }
        return res;
    }

    public boolean getFeature(final String name) throws IllegalArgumentException {
        return this.writer.getFeature(name);
    }

    public void setFeature(final String name, final boolean value) throws IllegalArgumentException {
        this.writer.setFeature(name, value);
    }

    @SuppressWarnings("unchecked")
    public String writeBPEL4WSDL(final Description wsdlDef) throws WSDL4BPELException {
        String res = null;
        try {
            res = this.writer.writeWSDL(((DecoratorDescriptionImpl) wsdlDef).getFirstDescription());
        } catch (final WSDLException e) {
            throw new WSDL4BPELException(e);
        }
        return res;
    }

}
